Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginDescription.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginDescription.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginDescription.cs	(revision 2771)
@@ -34,6 +34,6 @@
 
     [DataMember(Name = "Dependencies")]
-    private IEnumerable<PluginDescription> dependencies;
-    public IEnumerable<PluginDescription> Dependencies {
+    private List<PluginDescription> dependencies;
+    public List<PluginDescription> Dependencies {
       get { return dependencies; }
     }
@@ -51,5 +51,5 @@
       this.name = name;
       this.version = version;
-      this.dependencies = new List<PluginDescription>(dependencies).AsReadOnly();
+      this.dependencies = new List<PluginDescription>(dependencies); //.AsReadOnly();
       //this.isDatabaseInstance = true;
     }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginStore.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginStore.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.DataAccess/PluginStore.cs	(revision 2771)
@@ -10,95 +10,88 @@
   public class PluginStore {
 
-    private PluginStoreClassesDataContext ctx;
     public PluginStore() {
-      ctx = new PluginStoreClassesDataContext();
-    }
-
+    }
+
+    #region context creating members
     public IEnumerable<ProductDescription> Products {
       get {
-        return from p in ctx.Products
-               let plugins = from pair in ctx.ProductPlugins
-                             from plugin in ctx.Plugins
-                             where pair.ProductId == p.Id
-                             where plugin.Id == pair.PluginId
-                             select plugin
-               select MakeProductDescription(p, plugins);
-      }
-    }
-
-    private ProductDescription MakeProductDescription(Product p, IQueryable<Plugin> plugins) {
-      var desc = new ProductDescription(p.Id, p.Name, new Version(p.Version), from plugin in plugins
-                                                                              select MakePluginDescription(plugin));
-      return desc;
-    }
-
-    private PluginDescription MakePluginDescription(Plugin plugin) {
-      var desc = new PluginDescription(plugin.Id, plugin.Name, new Version(plugin.Version), from dep in GetDependencies(plugin)
-                                                                                            select MakePluginDescription(dep));
-      return desc;
-    }
-
-    private IEnumerable<Plugin> GetDependencies(Plugin plugin) {
-      return from pair in ctx.Dependencies
-             from dependency in ctx.Plugins
-             where pair.PluginId == plugin.Id
-             where pair.DependencyId == dependency.Id
-             select dependency;
+        using (var ctx = new PluginStoreClassesDataContext()) {
+          return (from p in ctx.Products
+                  let plugins = from pair in ctx.ProductPlugins
+                                from plugin in ctx.Plugins
+                                where pair.ProductId == p.Id
+                                where plugin.Id == pair.PluginId
+                                select plugin
+                  select MakeProductDescription(ctx, p, plugins)).ToList();
+        }
+      }
     }
 
     public IEnumerable<PluginDescription> Plugins {
       get {
-        return from plugin in ctx.Plugins
-               select MakePluginDescription(plugin);
+        using (var ctx = new PluginStoreClassesDataContext()) {
+          return (from plugin in ctx.Plugins
+                  select MakePluginDescription(ctx, plugin)).ToList();
+        }
       }
     }
 
     public byte[] PluginFile(PluginDescription pluginDescription) {
-      return GetExistingPlugin(pluginDescription.Name, pluginDescription.Version).PluginPackage.Data.ToArray();
+      using (var ctx = new PluginStoreClassesDataContext()) {
+        return GetExistingPlugin(ctx, pluginDescription.Name, pluginDescription.Version).PluginPackage.Data.ToArray();
+      }
     }
 
     public void Persist(PluginDescription pluginDescription, byte[] pluginPackage) {
-      try {
-        using (var transaction = new TransactionScope()) {
-          Plugin pluginEntity = InsertOrUpdatePlugin(pluginDescription);
-          if (pluginEntity.PluginPackage == null) {
-            // insert
-            pluginEntity.PluginPackage = MakePluginPackage(pluginDescription, pluginPackage);
-          } else {
-            // update
-            pluginEntity.PluginPackage.Data = pluginPackage;
+      using (var ctx = new PluginStoreClassesDataContext()) {
+        try {
+          using (var transaction = new TransactionScope()) {
+            Plugin pluginEntity = InsertOrUpdatePlugin(ctx, pluginDescription);
+            if (pluginEntity.PluginPackage == null) {
+              // insert
+              pluginEntity.PluginPackage = MakePluginPackage(pluginDescription, pluginPackage);
+            } else {
+              // update
+              pluginEntity.PluginPackage.Data = pluginPackage;
+            }
+            ctx.SubmitChanges();
+            transaction.Complete();
           }
-          ctx.SubmitChanges();
-          transaction.Complete();
-        }
-      }
-      catch (SqlException ex) {
-        throw new ArgumentException("Something went wrong while trying to persist plugin", ex);
-      }
-      catch (InvalidOperationException ex) {
-        throw new ArgumentException("Something went wrong while trying to persist plugin", ex);
+        }
+        catch (SqlException ex) {
+          throw new ArgumentException("Something went wrong while trying to persist plugin", ex);
+        }
+        catch (InvalidOperationException ex) {
+          throw new ArgumentException("Something went wrong while trying to persist plugin", ex);
+        }
       }
     }
 
     public void Persist(ProductDescription product) {
-      try {
-        using (var transaction = new TransactionScope()) {
-          InsertOrUpdateProduct(product);
-          foreach (var plugin in product.Plugins) {
-            InsertOrUpdatePlugin(plugin);
+      using (var ctx = new PluginStoreClassesDataContext()) {
+        try {
+          using (var transaction = new TransactionScope()) {
+            foreach (var plugin in product.Plugins) {
+              var pluginEntity = GetExistingPlugin(ctx, plugin.Name, plugin.Version);
+              UpdatePlugin(ctx, pluginEntity, plugin);
+            }
+            InsertOrUpdateProduct(ctx, product);
+            ctx.SubmitChanges();
+            transaction.Complete();
           }
-          ctx.SubmitChanges();
-          transaction.Complete();
-        }
-      }
-      catch (SqlException ex) {
-        throw new ArgumentException("Something went wrong while trying to persist product", ex);
-      }
-      catch (InvalidOperationException ex) {
-        throw new ArgumentException("Something went wrong while trying to persist product", ex);
-      }
-    }
-
-    private void InsertOrUpdateProduct(ProductDescription product) {
+        }
+        catch (SqlException ex) {
+          throw new ArgumentException("Something went wrong while trying to persist product", ex);
+        }
+        catch (InvalidOperationException ex) {
+          throw new ArgumentException("Something went wrong while trying to persist product", ex);
+        }
+      }
+    }
+
+    #endregion
+
+    #region insert/update product
+    private void InsertOrUpdateProduct(PluginStoreClassesDataContext ctx, ProductDescription product) {
       var productEntity = (from p in ctx.Products
                            where p.Name == product.Name
@@ -113,8 +106,8 @@
       product.Id = productEntity.Id;
 
-      DeleteOldPlugins(productEntity);
+      DeleteOldPlugins(ctx, productEntity);
 
       foreach (var plugin in product.Plugins) {
-        var existingPlugin = GetExistingPlugin(plugin.Name, plugin.Version);
+        var existingPlugin = GetExistingPlugin(ctx, plugin.Name, plugin.Version);
         ProductPlugin prodPlugin = new ProductPlugin();
         prodPlugin.PluginId = existingPlugin.Id;
@@ -124,5 +117,5 @@
     }
 
-    private void DeleteOldPlugins(Product productEntity) {
+    private void DeleteOldPlugins(PluginStoreClassesDataContext ctx, Product productEntity) {
       var oldPlugins = (from p in ctx.ProductPlugins
                         where p.ProductId == productEntity.Id
@@ -131,6 +124,8 @@
       ctx.SubmitChanges();
     }
-
-    private Plugin InsertOrUpdatePlugin(PluginDescription pluginDescription) {
+    #endregion
+
+    #region insert/update plugins
+    private Plugin InsertOrUpdatePlugin(PluginStoreClassesDataContext ctx, PluginDescription pluginDescription) {
       var pluginEntity = (from p in ctx.Plugins
                           where p.Name == pluginDescription.Name
@@ -142,10 +137,19 @@
         ctx.SubmitChanges();
       }
+
+      UpdatePlugin(ctx, pluginEntity, pluginDescription);
+      return pluginEntity;
+    }
+
+    private void UpdatePlugin(PluginStoreClassesDataContext ctx, Plugin pluginEntity, PluginDescription pluginDescription) {
+      // delete cached entry
+      if (pluginDescriptions.ContainsKey(pluginEntity)) pluginDescriptions.Remove(pluginEntity);
+
       pluginDescription.Id = pluginEntity.Id;
 
-      DeleteOldDependencies(pluginEntity);
+      DeleteOldDependencies(ctx, pluginEntity);
 
       foreach (var dependency in pluginDescription.Dependencies) {
-        var dependencyEntity = GetExistingPlugin(dependency.Name, dependency.Version);
+        var dependencyEntity = GetExistingPlugin(ctx, dependency.Name, dependency.Version);
         Dependency d = new Dependency();
         d.PluginId = pluginDescription.Id;
@@ -153,9 +157,9 @@
         ctx.Dependencies.InsertOnSubmit(d);
       }
-      return pluginEntity;
-
-    }
-
-    private void DeleteOldDependencies(Plugin pluginEntity) {
+    }
+
+
+
+    private void DeleteOldDependencies(PluginStoreClassesDataContext ctx, Plugin pluginEntity) {
       var oldDependencies = (from dep in ctx.Dependencies
                              where dep.PluginId == pluginEntity.Id
@@ -165,10 +169,32 @@
       ctx.SubmitChanges();
     }
-
-    private Plugin GetExistingPlugin(string name, Version version) {
-      return (from p in ctx.Plugins
-              where p.Name == name
-              where p.Version == version.ToString()
-              select p).Single();
+    #endregion
+
+    #region product <-> productDescription transformation
+    private ProductDescription MakeProductDescription(PluginStoreClassesDataContext ctx, Product p, IQueryable<Plugin> plugins) {
+      var desc = new ProductDescription(p.Id, p.Name, new Version(p.Version), from plugin in plugins
+                                                                              select MakePluginDescription(ctx, plugin));
+      return desc;
+    }
+    private Product MakeProductFromDescription(ProductDescription desc) {
+      var product = new Product();
+      product.Id = desc.Id;
+      product.Name = desc.Name;
+      product.Version = desc.Version.ToString();
+      return product;
+    }
+    #endregion
+
+    #region plugin <-> pluginDescription transformation
+    // cache for plugin descriptions
+    private Dictionary<Plugin, PluginDescription> pluginDescriptions = new Dictionary<Plugin, PluginDescription>();
+    private PluginDescription MakePluginDescription(PluginStoreClassesDataContext ctx, Plugin plugin) {
+      if (!pluginDescriptions.ContainsKey(plugin)) {
+        // no cached description -> create new
+        var desc = new PluginDescription(plugin.Id, plugin.Name, new Version(plugin.Version), from dep in GetDependencies(ctx, plugin)
+                                                                                              select MakePluginDescription(ctx, dep));
+        pluginDescriptions[plugin] = desc;
+      }
+      return pluginDescriptions[plugin];
     }
 
@@ -181,12 +207,4 @@
     }
 
-    private Product MakeProductFromDescription(ProductDescription desc) {
-      var product = new Product();
-      product.Id = desc.Id;
-      product.Name = desc.Name;
-      product.Version = desc.Version.ToString();
-      return product;
-    }
-
     private PluginPackage MakePluginPackage(PluginDescription pluginDescription, byte[] pluginPackage) {
       var package = new PluginPackage();
@@ -196,4 +214,23 @@
       return package;
     }
+
+    #endregion
+
+    #region helper queries
+    private Plugin GetExistingPlugin(PluginStoreClassesDataContext ctx, string name, Version version) {
+      return (from p in ctx.Plugins
+              where p.Name == name
+              where p.Version == version.ToString()
+              select p).Single();
+    }
+
+    private IEnumerable<Plugin> GetDependencies(PluginStoreClassesDataContext ctx, Plugin plugin) {
+      return from pair in ctx.Dependencies
+             from dependency in ctx.Plugins
+             where pair.PluginId == plugin.Id
+             where pair.DependencyId == dependency.Id
+             select dependency;
+    }
+    #endregion
   }
 }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/AdminTest.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/AdminTest.cs	(revision 2771)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/AdminTest.cs	(revision 2771)
@@ -0,0 +1,340 @@
+﻿using HeuristicLab.Services.Deployment;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Services.Deployment.DataAccess;
+using System;
+using System.Linq;
+using System.Text;
+using System.ServiceModel;
+using System.Diagnostics;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.Deployment.Test {
+
+
+  /// <summary>
+  ///This is a test class for AdminTest and is intended
+  ///to contain all AdminTest Unit Tests
+  ///</summary>
+  [TestClass()]
+  public class AdminTest {
+
+    private Encoding enc = new ASCIIEncoding();
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    #region Additional test attributes
+    // 
+    //You can use the following additional attributes as you write your tests:
+    //
+    //Use ClassInitialize to run code before running the first test in the class
+    //[ClassInitialize()]
+    //public static void MyClassInitialize(TestContext testContext)
+    //{
+    //}
+    //
+    //Use ClassCleanup to run code after all tests in a class have run
+    //[ClassCleanup()]
+    //public static void MyClassCleanup()
+    //{
+    //}
+    //
+    //Use TestInitialize to run code before running each test
+    //[TestInitialize()]
+    //public void MyTestInitialize()
+    //{
+    //}
+    //
+    //Use TestCleanup to run code after each test has run
+    //[TestCleanup()]
+    //public void MyTestCleanup()
+    //{
+    //}
+    //
+    #endregion
+
+
+    /// <summary>
+    ///A test for StoreProduct
+    ///</summary>
+    [TestMethod()]
+    public void DeployProductTest() {
+      var target = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+      var update = new HeuristicLab.Services.Deployment.Test.UpdateService.UpdateClient();
+      int oldCount = update.GetProducts().Count();
+
+      string prodName = RandomName();
+      Version vers01 = new Version("0.0.0.1");
+      ProductDescription product = new ProductDescription(prodName, vers01);
+      target.DeployProduct(product);
+
+      int newCount = update.GetProducts().Count();
+      Assert.AreEqual(oldCount + 1, newCount);
+    }
+
+    /// <summary>
+    ///A test for DeployPlugin
+    ///</summary>
+    [TestMethod()]
+    public void DeployPluginTest() {
+      var target = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+      var update = new HeuristicLab.Services.Deployment.Test.UpdateService.UpdateClient();
+
+      var vers01 = new Version(0, 1);
+
+      #region persist single plugin without dependencies
+      {
+        string name = RandomName();
+        int oldCount = update.GetPlugins().Count();
+        PluginDescription pluginDescription = new PluginDescription(name, vers01);
+        byte[] pluginPackage = enc.GetBytes("Zipped " + name);
+        target.DeployPlugin(pluginDescription, pluginPackage);
+        int newCount = update.GetPlugins().Count();
+        Assert.AreEqual(oldCount + 1, newCount);
+      }
+      #endregion
+
+      #region persist a product with same name and version as an existent product
+      {
+        string name = RandomName();
+        int oldCount = update.GetPlugins().Count();
+        PluginDescription pluginDescription = new PluginDescription(name, vers01);
+        byte[] pluginPackage = enc.GetBytes("Zipped " + name);
+        target.DeployPlugin(pluginDescription, pluginPackage);
+        int newCount = update.GetPlugins().Count();
+        Assert.AreEqual(oldCount + 1, newCount);
+
+        // insert same name and version
+        oldCount = update.GetPlugins().Count();
+        pluginDescription = new PluginDescription(name, vers01);
+        pluginPackage = enc.GetBytes("Zipped " + name);
+        target.DeployPlugin(pluginDescription, pluginPackage);
+        newCount = update.GetPlugins().Count();
+        // make sure old entry was updated
+        Assert.AreEqual(oldCount, newCount);
+
+        // insert new with different version
+        oldCount = update.GetPlugins().Count();
+        pluginDescription = new PluginDescription(name, new Version(0, 2));
+        pluginPackage = enc.GetBytes("Zipped " + name);
+        target.DeployPlugin(pluginDescription, pluginPackage);
+        newCount = update.GetPlugins().Count();
+        // make sure a new entry was created
+        Assert.AreEqual(oldCount + 1, newCount);
+      }
+      #endregion
+
+      #region persist a plugin with an already persisted dependency
+      {
+        string name = RandomName();
+        PluginDescription dependency = new PluginDescription(name, vers01);
+        // insert dependency first
+        target.DeployPlugin(dependency, enc.GetBytes("Zipped " + name));
+
+        // persist another plugin that has a dependency on the first plugin
+        string name2 = RandomName();
+        int oldCount = update.GetPlugins().Count();
+
+        PluginDescription newEntity = new PluginDescription(name2, vers01, Enumerable.Repeat(dependency, 1));
+        byte[] newEntityPackage = enc.GetBytes("Zipped " + name2);
+        target.DeployPlugin(newEntity, newEntityPackage);
+        int newCount = update.GetPlugins().Count();
+        Assert.AreEqual(oldCount + 1, newCount); // only one new plugin should be added
+
+        // retrieve second plugin and check dependencies
+        newEntity = update.GetPlugins().Where(p => p.Name == name2).Single();
+        Assert.AreEqual(newEntity.Dependencies.Count(), 1);
+        Assert.AreEqual(newEntity.Dependencies.First().Name, name);
+      }
+      #endregion
+
+      #region try to persist a new  plugin with a non-existant dependency and check the expected exception
+      {
+        // try to persist a new plugin with a non-existant dependency
+        try {
+          string pluginName = RandomName();
+          string dependencyName = RandomName();
+          var dependency = new PluginDescription(dependencyName, vers01);
+          var newEntity = new PluginDescription(pluginName, vers01, Enumerable.Repeat(dependency, 1));
+          target.DeployPlugin(newEntity, enc.GetBytes("Zipped " + pluginName));
+          Assert.Fail("persist should fail with ArgumentException");
+        }
+        catch (FaultException e) {
+          // this is expected
+          Assert.IsTrue(true, "expected exception");
+
+          // reconnect service
+          target = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+        }
+      }
+      #endregion
+
+      #region update the plugin file of an existing plugin
+      {
+        // insert new plugin
+        string pluginName = RandomName();
+        var newPlugin = new PluginDescription(pluginName, vers01);
+        target.DeployPlugin(newPlugin, enc.GetBytes("Zipped " + pluginName));
+
+        // update the plugin file
+        byte[] expected = enc.GetBytes("Zipped2 " + pluginName);
+        target.DeployPlugin(newPlugin, expected);
+        // check if the updated file is returned
+        byte[] actual = update.GetPlugin(newPlugin);
+        // check retrieved file
+        Assert.AreEqual(expected.Length, actual.Length);
+        for (int i = 0; i < expected.Length; i++) {
+          Assert.AreEqual(expected[i], actual[i]);
+        }
+      }
+      #endregion
+
+      #region update the dependencies of an existing plugin
+      {
+        string dependency1Name = RandomName();
+        var newDependency1 = new PluginDescription(dependency1Name, vers01);
+        target.DeployPlugin(newDependency1, enc.GetBytes("Zipped " + dependency1Name));
+
+        string pluginName = RandomName();
+        var newPlugin = new PluginDescription(pluginName, vers01, Enumerable.Repeat(newDependency1, 1));
+        target.DeployPlugin(newPlugin, enc.GetBytes("Zipped " + pluginName));
+
+        // retrieve plugin
+        var dbPlugin = update.GetPlugins().Where(p => p.Name == pluginName).Single();
+        Assert.AreEqual(dbPlugin.Dependencies.Count(), 1);
+        Assert.AreEqual(dbPlugin.Dependencies.First().Name, dependency1Name);
+
+        // change dependencies 
+        string dependency2Name = RandomName();
+        var newDependency2 = new PluginDescription(dependency2Name, vers01);
+        target.DeployPlugin(newDependency2, enc.GetBytes("Zipped " + pluginName));
+
+        newPlugin = new PluginDescription(pluginName, vers01, new PluginDescription[] { newDependency1, newDependency2 });
+        target.DeployPlugin(newPlugin, enc.GetBytes("Zipped " + pluginName));
+        // retrieve plugin
+        dbPlugin = update.GetPlugins().Where(p => p.Name == pluginName).Single();
+        Assert.AreEqual(dbPlugin.Dependencies.Count(), 2);
+      }
+      #endregion
+
+      #region try to insert a plugin that references the same dependency twice and check if the correct exception is thrown
+      {
+        string depName = RandomName();
+        var depPlugin = new PluginDescription(depName, vers01);
+        target.DeployPlugin(depPlugin, enc.GetBytes("Zipped " + depName));
+
+        // insert new plugin
+        string pluginName = RandomName();
+        var plugin = new PluginDescription(pluginName, vers01, new PluginDescription[] { depPlugin, depPlugin });
+        try {
+          target.DeployPlugin(plugin, enc.GetBytes("Zipped " + depName));
+          Assert.Fail("Expected ArgumentException");
+        }
+        catch (FaultException) {
+          Assert.IsTrue(true, "Exception thrown as expected");
+          // reconnect
+          target = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+        }
+      }
+      #endregion
+
+      #region try to insert a plugin that with a cyclic reference
+      {
+        string depName = RandomName();
+        var depPlugin = new PluginDescription(depName, vers01);
+        target.DeployPlugin(depPlugin, enc.GetBytes("Zipped " + depName));
+
+        // update the plugin so that it has a dependency on itself 
+        var plugin = new PluginDescription(depName, vers01, new PluginDescription[] { depPlugin });
+        try {
+          target.DeployPlugin(plugin, enc.GetBytes("Zipped " + depName));
+          Assert.Fail("Expected ArgumentException");
+        }
+        catch (FaultException) {
+          target = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+          Assert.IsTrue(true, "Exception thrown as expected");
+        }
+      }
+      #endregion
+    }
+
+    [TestMethod]
+    public void DeployPluginPerformanceTest() {
+      int nPlugins = 100;
+      int maxDependencies = 10;
+      int avgZipFileLength = 32000;
+
+      var adminClient = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+      var updateClient = new HeuristicLab.Services.Deployment.Test.UpdateService.UpdateClient();
+      Version vers01 = new Version(0, 1);
+      // create a random byte array to represent file length
+      byte[] zippedConstant = new byte[avgZipFileLength];
+      Random r = new Random();
+      r.NextBytes(zippedConstant);
+
+      Stopwatch stopWatch = new Stopwatch();
+      stopWatch.Start();
+      // create plugins
+      for (int i = 0; i < nPlugins; i++) {
+        string name = RandomName();
+        var allPlugins = updateClient.GetPlugins();
+        if (allPlugins.Length > maxDependencies) {
+          PluginDescription[] dependencies = new PluginDescription[maxDependencies];
+          for (int j = 0; j < maxDependencies; j++) {
+            dependencies[j] = allPlugins[j];
+          }
+          var plugin = new PluginDescription(name, vers01, dependencies);
+          adminClient.DeployPlugin(plugin, zippedConstant);
+        } else {
+          var plugin = new PluginDescription(name, vers01, allPlugins);
+          adminClient.DeployPlugin(plugin, zippedConstant);
+        }
+      }
+      stopWatch.Stop();
+      Assert.Inconclusive("Created " + nPlugins + " plugins in " + stopWatch.ElapsedMilliseconds +
+        " ms (" + (double)stopWatch.ElapsedMilliseconds / nPlugins + " ms / plugin )");
+    }
+    [TestMethod]
+    public void DeployProductPerformanceTest() {
+      int nProducts = 50;
+      int avgProductPlugins = 30;
+
+      var adminClient = new HeuristicLab.Services.Deployment.Test.AdminService.AdminClient();
+      var updateClient = new HeuristicLab.Services.Deployment.Test.UpdateService.UpdateClient();
+      Version vers01 = new Version(0, 1);
+      Stopwatch stopWatch = new Stopwatch();
+      Random r = new Random();
+      var plugins = updateClient.GetPlugins().ToList();
+      stopWatch.Start();
+      // create products
+      for (int i = 0; i < nProducts; i++) {
+        string name = RandomName();
+        List<PluginDescription> prodPlugins = new List<PluginDescription>();
+        for (int j = 0; j < avgProductPlugins; j++) {
+          var selectedPlugin = plugins[r.Next(0, plugins.Count)];
+          if (!prodPlugins.Contains(selectedPlugin)) prodPlugins.Add(selectedPlugin);
+        }
+        var prod = new ProductDescription(name, vers01, prodPlugins);
+        adminClient.DeployProduct(prod);
+      }
+      stopWatch.Stop();
+      Assert.Inconclusive("Created " + nProducts + " products in " + stopWatch.ElapsedMilliseconds +
+        " ms (" + (double)stopWatch.ElapsedMilliseconds / nProducts + " ms / product )");
+    }
+
+    private string RandomName() {
+      return Guid.NewGuid().ToString();
+    }
+  }
+}
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/HeuristicLab.Services.Deployment.Test.csproj
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/HeuristicLab.Services.Deployment.Test.csproj	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/HeuristicLab.Services.Deployment.Test.csproj	(revision 2771)
@@ -47,4 +47,7 @@
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.ServiceModel">
+      <RequiredTargetFramework>3.0</RequiredTargetFramework>
+    </Reference>
     <Reference Include="System.Xml" />
     <Reference Include="System.Xml.Linq">
@@ -53,9 +56,32 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="AdminTest.cs" />
     <Compile Include="PluginStoreTest.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Service References\AdminService\Reference.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Reference.svcmap</DependentUpon>
+    </Compile>
+    <Compile Include="Service References\UpdateService\Reference.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Reference.svcmap</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
     <Content Include="AuthoringTests.txt" />
+    <None Include="Service References\AdminService\Reference.svcmap">
+      <Generator>WCF Proxy Generator</Generator>
+      <LastGenOutput>Reference.cs</LastGenOutput>
+    </None>
+    <None Include="Service References\AdminService\configuration.svcinfo" />
+    <None Include="Service References\AdminService\configuration91.svcinfo" />
+    <None Include="Service References\UpdateService\Reference.svcmap">
+      <Generator>WCF Proxy Generator</Generator>
+      <LastGenOutput>Reference.cs</LastGenOutput>
+    </None>
+    <None Include="Service References\UpdateService\configuration.svcinfo" />
+    <None Include="Service References\UpdateService\configuration91.svcinfo" />
   </ItemGroup>
   <ItemGroup>
@@ -64,4 +90,30 @@
       <Name>HeuristicLab.Services.Deployment.DataAccess</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Services.Deployment\HeuristicLab.Services.Deployment.csproj">
+      <Project>{30D8C5F1-CD3A-4EC1-907F-430177A03FBE}</Project>
+      <Name>HeuristicLab.Services.Deployment</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <WCFMetadata Include="Service References\" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="app.config" />
+    <None Include="Properties\DataSources\HeuristicLab.Services.Deployment.DataAccess.PluginDescription.datasource" />
+    <None Include="Properties\DataSources\HeuristicLab.Services.Deployment.DataAccess.ProductDescription.datasource" />
+    <None Include="Service References\AdminService\HeuristicLab.Services.Deployment.DataAccess.xsd" />
+    <None Include="Service References\AdminService\service.wsdl" />
+    <None Include="Service References\AdminService\service.xsd" />
+    <None Include="Service References\AdminService\service1.xsd" />
+    <None Include="Service References\AdminService\System.xsd" />
+    <None Include="Service References\UpdateService\HeuristicLab.Services.Deployment.DataAccess.xsd" />
+    <None Include="Service References\UpdateService\service.wsdl" />
+    <None Include="Service References\UpdateService\service.xsd" />
+    <None Include="Service References\UpdateService\service1.xsd" />
+    <None Include="Service References\UpdateService\System.xsd" />
+  </ItemGroup>
+  <ItemGroup>
+    <WCFMetadataStorage Include="Service References\AdminService\" />
+    <WCFMetadataStorage Include="Service References\UpdateService\" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
